/* GCC */
#include <iostream>
#include <vector>
#include <cstdio>

using namespace std;
vector <bool> used,win;
vector <long> frst,scnd;
long mn = 0;

bool check(long a,long b)
{
    vector <long> dif;
    long i = 0;
    while (a>0||b>0)
    {
        if (b%2>a%2) return 0;
        if (a%2>b%2) dif.push_back(i);
        i++;
        if (dif.size()>2) return 0;
        a/=2;
        b/=2;
    }
    if (dif.size()<2) return 1;
    if (dif[1]-dif[0]==1) return 1;
    return 0;
}

void obr(long a,long b)
{

    long t = 2,st = 1,d = a - b;
    while(d>t){
        t*=2;
        st++;
    }

    if (t==d) frst.push_back(st);
    else scnd.push_back(st-2);
}

bool dfs(long pos,long dpt)
{
  //  cout<<pos<<'\n';
    if (used[pos]) return win[pos];
    used[pos]=1;
    if (pos==0){
        win[pos]=1;
        return 1;
    }
    for (long i = pos-1;i>=0;i--)
        if (check(pos,i))
            if (!dfs(i,dpt+1)) {
                if (dpt!=1){
                win[pos] = 1;
                return 1;
                }
                else obr(pos,i);
            }


    return win[pos];

}

long step(long pok)
{
    if (pok==0) return 1;
    if (pok==1) return 2;
    long tmp = step(pok/2);
    if (pok%2==0) return tmp*tmp;
    return tmp*tmp*2;
}

int main(){
    freopen("game.in","r",stdin);
    freopen("game.out","w",stdout);
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    frst.clear();
    scnd.clear();
    long temp;
    while(cin>>temp){
        mn+=step(temp);
    }
    used.resize(mn+5,0);
    win.resize(mn+5,0);
  //  cout<<mn;
    dfs(mn,1);
    for (long i = 0;i < frst.size();i++)
        if (i!=frst.size()-1) cout<<frst[i]<<' ';
        else cout<<frst[i];
    cout<<'\n';
    for (long i = 0;i < scnd.size();i++)
        if (i!=scnd.size()-1) cout<<scnd[i]<<' ';
        else cout<<scnd[i];
    cout<<'\n';
    return 0;
}
