/* GCC */
/* I do love that problem*/
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>
#include <sstream>
#include <list>

using namespace std;

#define MAX 2e9

struct Edge {
    int u, DepartTime, ArriveTime, Cost;
    Edge(){};
    Edge(int _u, int _DepartTime, int _ArriveTime, int _Cost) : u(_u), Cost(_Cost), DepartTime(_DepartTime), ArriveTime(_ArriveTime){};
};

vector<Edge> Graph[300];
list<pair<int , int> > State[300];
char read_buf[50000];
int n, m, t0, start, finish;

int main() {
    freopen("tax.in", "r", stdin);
    freopen("tax.out", "w", stdout);

    scanf("%d %d %d %d %d\n", &n, &m, &t0, &start, &finish);

    for(int i = 1; i <= m; i++) {
        gets(read_buf);
        stringstream S(read_buf);

        int PrevV = -1, CurV, Cost, ArriveTime, DepartTime;
        for(; S >> CurV >> ArriveTime >> Cost; PrevV = CurV , DepartTime = ArriveTime )
            if(PrevV != -1)
                Graph[PrevV].push_back(Edge(CurV , DepartTime , ArriveTime , Cost));
    };

    State[start].push_back(make_pair(0, t0));
    bool upd = true;

    for(int j = 1; j <= n && upd; j++) {
        upd = false;
         for(int v = 1; v <= n; v ++ ) for(list<pair<int , int> >::iterator itv = State[v].begin(); itv != State[v].end(); itv ++ ) {
            int cur_cost = itv->first;
            int cur_time = itv->second;
            for(int i = 0; i < Graph[v].size(); i++) {
                int next_cost = cur_cost;
                int next_time = cur_time;
                if(next_time % 1440 > Graph[v][i].DepartTime)
                    next_time = (next_time / 1440 + 1) * 1440;

                next_time = next_time / 1440 * 1440 + Graph[v][i].ArriveTime;
                next_cost += Graph[v][i].Cost;
                int u = Graph[v][i].u;
                bool can_insert = true;
                for(list<pair<int , int> >::iterator itu = State[u].begin(); itu != State[u].end();) {
                    if(itu->first <= next_cost && itu->second <= next_time) {
                        can_insert = false;
                        break;
                    }

                    if (itu->first >= next_cost && itu->second >= next_time)
                        itu = State[u].erase(itu);
                    else itu++;
                }
                if(can_insert) {
                    upd = true;
                    State[u].push_back(make_pair(next_cost, next_time));
                }
            }
         }
    }


    pair <int, int> answer_1(MAX, MAX);
    pair <int, int> answer_2(MAX, MAX);

    for(list<pair<int, int> >::iterator itu = State[finish].begin(); itu != State[finish].end(); itu++) {

        if(itu->first < answer_2.first || (itu->first == answer_2.first && itu->second < answer_2.second))
            answer_2 = *itu;

        if(itu->second < answer_1.second || (itu->second == answer_1.second && itu->first < answer_1.first))
            answer_1 = *itu;
    };

    printf("%d %d\n%d %d\n", answer_1.second, answer_1.first, answer_2.second, answer_2.first);

    return 0;
}
